commit fa38c8b46eec550aee7e561c5b4b7c01a4ef42e3
Author: Kewen Lin <linkw@linux.ibm.com>
Date:   Mon Sep 26 00:33:18 2022 -0500

    rs6000: Fix the condition with frame_pointer_needed_indeed [PR96072]
    
    As PR96072 shows, the code adding REG_CFA_DEF_CFA reg note
    makes one assumption that we have emitted one insn which
    restores the frame pointer previously.  That part of code
    was guarded with flag frame_pointer_needed before, it was
    consistent, but it was replaced with flag
    frame_pointer_needed_indeed since commit r10-7981.  It
    caused ICE due to unexpected NULL insn.
    
            PR target/96072
    
    gcc/ChangeLog:
    
            * config/rs6000/rs6000-logue.c (rs6000_emit_epilogue): Update the
            condition for adding REG_CFA_DEF_CFA reg note with
            frame_pointer_needed_indeed.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/powerpc/pr96072.c: New test.
    
    (cherry picked from commit 5be0950d22209f5ba69d244387228e12389a8470)

diff --git a/gcc/config/rs6000/rs6000-logue.c b/gcc/config/rs6000/rs6000-logue.c
index fbde3b62f48..ebfc3ff868f 100644
--- a/gcc/config/rs6000/rs6000-logue.c
+++ b/gcc/config/rs6000/rs6000-logue.c
@@ -4885,7 +4885,7 @@ rs6000_emit_epilogue (enum epilogue_type epilogue_type)
 	 a REG_CFA_DEF_CFA note, but that's OK;  A duplicate is
 	 discarded by dwarf2cfi.c/dwarf2out.c, and in any case would
 	 be harmless if emitted.  */
-      if (frame_pointer_needed)
+      if (frame_pointer_needed_indeed)
 	{
 	  insn = get_last_insn ();
 	  add_reg_note (insn, REG_CFA_DEF_CFA,
diff --git a/gcc/testsuite/gcc.target/powerpc/pr96072.c b/gcc/testsuite/gcc.target/powerpc/pr96072.c
new file mode 100644
index 00000000000..10341c91d2f
--- /dev/null
+++ b/gcc/testsuite/gcc.target/powerpc/pr96072.c
@@ -0,0 +1,14 @@
+/* { dg-options "-O2" } */
+
+/* This used to ICE with the SYSV ABI (PR96072).  */
+
+void
+he (int jn)
+{
+  {
+    int bh[jn];
+    if (jn != 0)
+      goto wa;
+  }
+wa:;
+}

